Subject: RE: [External] : Re: bug#54191: 26.3; (elisp) `Magic File Names' FILENAME parameters: absolute names?

From: Drew Adams <[email-masked]>
Date: Mon, 28 Feb 2022 18:32:15 +0000

> > > > No mention of absolute or relative in that node.
> > >
> > > It _shows_ them.
> >
> > I don't see any showing of a relative file name.
> 
> Exactly.

 ez> It shows them [absolute & relative file names].
 da>> I don't see it showing relative names.
 ez>>> Exactly.

Wow.

Showing only absolute names doesn't say what
happens when a relative name is passed.

> > > There's no more general problem here.
> >
> > FILENAME in `Remote Files'
> > FILENAME and FILE in `Magic File Names'
> > FILENAME in `Visiting Functions'
> > FILENAME in `Subroutines of Visiting'
> > FILENAME in `Saving Buffers'
> > FILENAME in `Reading from Files'
> > FILENAME in `Writing to Files'
> > FILENAME and FILE in `File Locks'
> > ...
> > and so on - lots of places.
> 
> These are just references to file names.  How is that a problem?

As the bug report requests: The doc should say
how the function handles relative and absolute
file-name args.  ("How" meaning what it does,
not "how" meaning the function's implementation.)

It's a problem that we don't tell users this.

> Anyway, that's the implementation.  We aren't 
> talking about the implementation.

??

We're talking about the behavior of a function;
specifically, how it handles a file-name arg
that is a relative or an absolute name.

We're not (I'm not) talking about how the
function is implemented.  We're (I am) talking
about its _behavior_ - what it does.

> > The question of whether a function does that,
> > and more generally how a function handles a
> > relative vs absolute file-name arg, is not
> > nothing.
> 
> From "File Names" in the Emacs user manual:
> 
>   Emacs always assumes that any relative file name
>   is relative to the default directory, e.g., entering a file
>   name without a directory specifies a file in the default directory.
> 
> This is so central to Emacs handling of file names that I'm astonished
> that someone who uses Emacs and programs for Emacs for so many years
> doesn't know that.

You know that I do know that. But you just love
to poke, don't you, Eli?

That text is irrelevant to this bug report.  No
one said that we don't tell users what relative
and absolute file names are, or that a relative
name is by default resolved using the value of
`default-directory'.

And you omitted the context of that sentence:

 "Whenever Emacs reads a file name using the
  minibuffer"

That context is irrelevant to this bug.  But
I think you realize that.  This bug is about
documenting the behavior of functions that
accept file-name arguments - calling out what
they do for a relative vs absolute name.

It's clear that you don't want to fix this bug.
Fine; though that's too bad.

But you apparently want to go on and on about
this, even though the bug was closed.  I've
felt obliged to respond to your extraneous,
irrelevant arguments.  I hope you're done with
them now - please consider giving it a rest.
We both deserve that, I think.